#ifndef _Qfax_parse_h
#define _Qfax_parse_h

#include "qfaxvers.h"
#include "qheader.h"

typedef struct
{
    short type;
    char  paged;
    char  show;
    char *name;
} XPL;

typedef struct _alias
{
    struct _alias *next;
    char   phone[40];
    char   alias[40];
    char   abbrev[16];
    char   dcode[40];
    unsigned short  flag;
} ALIAS;

typedef struct _prview
{
    struct _prview *next;
    char   *program;
    char   *file;
    short  value;
} PRVIEW;

typedef struct
{
    ALIAS *alias;
    char LocalId[64];
    char serdev[32];
    char preinit[64];
    char init[64];
    char in_dir[64];
    char info_file[64];
    char Signature[64];
    char Font[40];
    char Temp[32];
    char via[32];
    int  baud;
    int  ebaud;
    short delay;
    char res;
    char vmodem;
    char code;
    char sendrev;
    char _spare_;
    char wait2send;
    char startchar;
    char devunit;
    char width;
    char page; 
    char width_g3;
    char page_g3; 
    char paper;
    char unlimited[1];
    char nodata;
    char ppr;
    short lmargin;
    char pcmd[64];
    char ini[4][64];
    char dialcmd[16];
    char inicmd[16];
    char *qfaxini;
    char *qfv2ini;
    char *t2g3ini;
    char *pfaxini;
    char *mstr;
    char *dstr;
#ifdef QDOS
    char mono[1];
#endif
    char arrivals[40];
    char suffix[16];
    char rmodem;
    char elsb[1];
    char poll[1];
    char data[64];
    short iwait;
#ifdef QDOS
    char nul[40];
#endif
    short gdelay;
    short rclass;
    short sclass;
    short faa;
    char  indial[40];
    char  phonebook[40];
#ifdef QDOS
    char ScriptLog[40];
    char StartScript[40];
    char StopScript[40];
    short sflag;
#endif
    char  apres[32];
    short tg3;
    PRVIEW *prview;
    char fontdir[64];
    short edr;
    short report;
    char prescan[1];
    char hangup[1];
#ifdef QDOS
    int sbaud;
#endif
    char ec[1];
    char twodot[1];
} FAXDATA, *PFAXDATA;

#ifdef QDOS
#define QFAX_FILE "qfax_dat"
#define __stkargs
#else
# if defined (__linux__) || defined(__NT__)
#  define QFAX_FILE ".qfaxrc"
   extern unsigned short swapword (unsigned short);
   extern unsigned long swaplong (unsigned long);
   extern void HeaderEndianise(QFAXHEADER *);
   extern void OffrecEndianise(OFFREC *);
   extern FILE * lopen (const char *, const char *);
#  ifdef __linux__
#   define strnicmp strncasecmp
#   define stricmp strcasecmp
#  endif
# else
#  define QFAX_FILE "s:qfax.dat"
# endif
#endif

extern void FaxParams(PFAXDATA);
extern void FreeAlias(PFAXDATA);
extern void FrigArgs(int *, char ***, char *);
extern XPL *XLateXPL(short, char *);
extern void ListXPL(FILE *, char *);
extern void ShowReport (FAXDATA *, short, char *,...);

#ifndef offsetof
#define offsetof(sname,fname) ((long)&((sname *)0)->fname)
#endif

typedef struct
{
    char *id;
    void (*func)(void *, void *, int);
    long offset;
    int  mval;
    short flag;
} PARSELIST, *PPARSELIST;

#define REP_TG3 1
#define REP_QFV 2
#define REP_QFX 4
#define REP_PRT 8

#endif



